summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorFrancisco Redondo Marchena <francisco.marchena@codethink.co.uk>2015-01-28 10:32:57 +0000
committerPedro Alvarez <pedro.alvarez@codethink.co.uk>2015-01-28 17:37:30 +0000
commita7a465ca482fcd4e9cdfb0613f90fdaa234e5e78 (patch)
tree2a96d535b591bd1d17098cc311e49bfaa9f48e37
parent0f3469b5ac230d831c191776bcecdd50da558295 (diff)
downloaddefinitions-a7a465ca482fcd4e9cdfb0613f90fdaa234e5e78.tar.gz
Recreate links on boot and set bridges to ethernet automatically
openvswitch services need to run after network-online.target in order to have the ethernet device available and configured.
-rw-r--r--openstack/etc/systemd/system/openstack-neutron-network-configuration-one-node.service2
-rw-r--r--openstack/etc/systemd/system/openvswitch-create-links-one-node.service11
-rw-r--r--openstack/etc/systemd/system/openvswitch-db-server.service4
-rw-r--r--openstack/etc/systemd/system/openvswitch-setup.service3
-rw-r--r--openstack/etc/systemd/system/openvswitch.service4
-rw-r--r--openstack/manifest2
-rw-r--r--openstack/usr/share/openstack/create_openvswitch_veth_pairs32
-rw-r--r--openstack/usr/share/openstack/openstack-neutron-network-configuration-for-one-node12
8 files changed, 60 insertions, 10 deletions
diff --git a/openstack/etc/systemd/system/openstack-neutron-network-configuration-one-node.service b/openstack/etc/systemd/system/openstack-neutron-network-configuration-one-node.service
index 9dbbf49b..85bdb98c 100644
--- a/openstack/etc/systemd/system/openstack-neutron-network-configuration-one-node.service
+++ b/openstack/etc/systemd/system/openstack-neutron-network-configuration-one-node.service
@@ -1,7 +1,7 @@
[Unit]
Description=Configuration script to set Openstack in one node networking
Requires=openvswitch-setup.service openvswitch-db-server.service openvswitch.service
-After=network.target openvswitch-setup.service openvswitch-db-server.service openvswitch.service
+After=network-online.target openvswitch-setup.service openvswitch-db-server.service openvswitch.service openvswitch-create-links-one-node.service
[Service]
Type=simple
diff --git a/openstack/etc/systemd/system/openvswitch-create-links-one-node.service b/openstack/etc/systemd/system/openvswitch-create-links-one-node.service
new file mode 100644
index 00000000..0ffcf3e2
--- /dev/null
+++ b/openstack/etc/systemd/system/openvswitch-create-links-one-node.service
@@ -0,0 +1,11 @@
+[Unit]
+Description=Create Veth pairs
+After=network-online.target
+
+[Service]
+Type=simple
+ExecStart=/usr/share/openstack/create_openvswitch_veth_pairs
+
+[Install]
+WantedBy=multi-user.target
+
diff --git a/openstack/etc/systemd/system/openvswitch-db-server.service b/openstack/etc/systemd/system/openvswitch-db-server.service
index 8fc5ecb1..d3f4998f 100644
--- a/openstack/etc/systemd/system/openvswitch-db-server.service
+++ b/openstack/etc/systemd/system/openvswitch-db-server.service
@@ -1,7 +1,7 @@
[Unit]
Description=Open vSwitch Database server Daemon
-Requires=openvswitch-setup.service
-After=openvswitch-setup.service
+Requires=openvswitch-setup.service openvswitch-create-links-one-node.service
+After=network-online.target openvswitch-setup.service openvswitch-create-links-one-node.service
[Service]
Type=forking
diff --git a/openstack/etc/systemd/system/openvswitch-setup.service b/openstack/etc/systemd/system/openvswitch-setup.service
index ff55909d..ad7a144f 100644
--- a/openstack/etc/systemd/system/openvswitch-setup.service
+++ b/openstack/etc/systemd/system/openvswitch-setup.service
@@ -1,6 +1,7 @@
[Unit]
Description=Run openvswitch-setup (once)
-Requires=local-fs.target network.target
+Requires=local-fs.target network-online.target openvswitch-create-links-one-node.service
+After=network-online.target openvswitch-create-links-one-node.service
[Service]
Type=oneshot
diff --git a/openstack/etc/systemd/system/openvswitch.service b/openstack/etc/systemd/system/openvswitch.service
index 25320190..3da9e345 100644
--- a/openstack/etc/systemd/system/openvswitch.service
+++ b/openstack/etc/systemd/system/openvswitch.service
@@ -1,7 +1,7 @@
[Unit]
Description=Open vSwitch Daemon
-Requires=network.target openvswitch-db-server.service openvswitch-initialize-db.service
-After=network.target openvswitch-db-server.service openvswitch-initialize-db.service
+Requires=network-online.target openvswitch-db-server.service openvswitch-initialize-db.service
+After=network-online.target openvswitch-db-server.service openvswitch-initialize-db.service
[Service]
Type=forking
diff --git a/openstack/manifest b/openstack/manifest
index 03f1779f..767277ca 100644
--- a/openstack/manifest
+++ b/openstack/manifest
@@ -182,3 +182,5 @@
0100644 0 0 /etc/horizon/apache-horizon.conf
0100644 0 0 /etc/horizon/openstack_dashboard/local_settings.py
0100644 0 0 /etc/sysctl.conf
+0100644 0 0 /etc/systemd/system/openvswitch-create-links-one-node.service
+0100755 0 0 /usr/share/openstack/create_openvswitch_veth_pairs
diff --git a/openstack/usr/share/openstack/create_openvswitch_veth_pairs b/openstack/usr/share/openstack/create_openvswitch_veth_pairs
new file mode 100644
index 00000000..1e21ea6e
--- /dev/null
+++ b/openstack/usr/share/openstack/create_openvswitch_veth_pairs
@@ -0,0 +1,32 @@
+#!/bin/sh
+#
+# Copyright (C) 2015 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -xe
+
+# Get the first ethernet driver and its ip
+eth_dev="$(ip addr | perl -pe 'if (/^\d+: ([^:]+)/) { $iface=$1; } if (m@^\s*inet ([^/]+)/@) { print "$iface $1\n"; } $_=undef;' | grep "^e" | head -1 | awk '{ print $1 } ')"
+eth_ip="$(ip addr | perl -pe 'if (/^\d+: ([^:]+)/) { $iface=$1; } if (m@^\s*inet ([^/]+)/@) { print "$iface $1\n"; } $_=undef;' | grep "^e" | head -1 | awk '{ print $2 } ')"
+
+# Create the veth pairs between bridges (configuration one node)
+ifconfig br-eth0 $eth_ip up
+ip link set br-eth0 promisc on
+ip link add proxy-br-eth1 type veth peer name eth1-br-proxy
+ip link add proxy-br-ex type veth peer name ex-br-proxy
+ip link set eth1-br-proxy up promisc on
+ip link set ex-br-proxy up promisc on
+ip link set proxy-br-eth1 up promisc on
+ip link set proxy-br-ex up promisc on
diff --git a/openstack/usr/share/openstack/openstack-neutron-network-configuration-for-one-node b/openstack/usr/share/openstack/openstack-neutron-network-configuration-for-one-node
index 9108669a..a88bc0df 100644
--- a/openstack/usr/share/openstack/openstack-neutron-network-configuration-for-one-node
+++ b/openstack/usr/share/openstack/openstack-neutron-network-configuration-for-one-node
@@ -17,6 +17,10 @@
set -xe
+# Get the first ethernet driver and its ip
+eth_dev="$(ip addr | perl -pe 'if (/^\d+: ([^:]+)/) { $iface=$1; } if (m@^\s*inet ([^/]+)/@) { print "$iface $1\n"; } $_=undef;' | grep "^e" | head -1 | awk '{ print $1 } ')"
+eth_ip="$(ip addr | perl -pe 'if (/^\d+: ([^:]+)/) { $iface=$1; } if (m@^\s*inet ([^/]+)/@) { print "$iface $1\n"; } $_=undef;' | grep "^e" | head -1 | awk '{ print $2 } ')"
+
if [ -f /var/openstack/openvswitch-one-node-setup ]; then
exit 0
fi
@@ -25,12 +29,12 @@ fi
# This configuration is for 1 node and it was taken from:
# https://fosskb.wordpress.com/2014/10/18/openstack-juno-on-ubuntu-14-10/
# and https://fosskb.wordpress.com/2014/06/10/managing-openstack-internaldataexternal-network-in-one-interface/
+
+
ovs-vsctl add-br br-eth0
-ovs-vsctl add-port br-eth0 ens3
-ifconfig br-eth0 $(hostname -i | awk '{ print $1 }') up
+ovs-vsctl add-port br-eth0 $eth_dev
+ifconfig br-eth0 $eth_ip up
ip link set br-eth0 promisc on
-ip link add proxy-br-eth1 type veth peer name eth1-br-proxy
-ip link add proxy-br-ex type veth peer name ex-br-proxy
ovs-vsctl add-br br-eth1
ovs-vsctl add-br br-ex
ovs-vsctl add-port br-eth1 eth1-br-proxy